<template>
  <div class="preloader-wrap">
    <svg id="ebd3954p4wgk1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"
         viewBox="0 0 72 72" shape-rendering="geometricPrecision" text-rendering="geometricPrecision">
      <defs>
        <clipPath id="preloader_1">
          <rect id="preloader_2" width="72" height="60" rx="0" ry="0" fill="rgb(0,0,0)" stroke="none"
                stroke-width="1" />
        </clipPath>
      </defs>
      <g id="preloader" transform="translate(36,36) rotate(0)">
        <g id="preloader_line_1" transform="translate(-36,-30)" clip-path="url(#preloader_1)">
          <rect id="preloader_line_2" width="72" height="72" rx="0" ry="0"
                transform="matrix(1 0 0 1 0 -6.00000000000001)" fill="transparent" stroke="none"
                stroke-width="1" />
          <g id="preloader_line_3" transform="matrix(1 0 0 1 -115 -20)">
            <rect id="ebd3954p4wgk7" width="36" height="14" rx="0" ry="0" transform="matrix(1 0 0 1 151 43)"
                  fill="rgb(0,74,199)" stroke="none" stroke-width="1" />
          </g>
          <circle id="preloader_line_4" r="30" transform="matrix(1 0 0 1 36 30)" fill="rgb(0,74,199)"
                  stroke="none" stroke-width="1" />
          <circle id="preloader_line_5" r="13" transform="matrix(-1 0 -0 -1 36 30)" fill="#E4EDF9"
                  stroke="none" stroke-width="1" />
          <circle id="preloader_line_6" r="6" transform="matrix(-1 0 -0 -1 36 30)" fill="rgb(0,74,199)"
                  stroke="none" stroke-width="1" />
        </g>
      </g>
    </svg>
  </div>
</template>
<script>
import { TimelineMax } from '@/plugins/gsap/esm'
import '@/plugins/gsap/npm/DrawSVGPlugin.js'
import MorphSVGPlugin from "@/plugins/gsap/npm/MorphSVGPlugin"

export default {
  name: "PreloaderOboz",
  data () {
    return {
      tl: null,
      all: null
    }
  },
  mounted () {
    this.startAll()
  },
  methods: {

    startAll () {
      this.setToDefault()
      this.animatePreload()
    },

    animatePreload () {
      this.tl.staggerTo(this.all, .5, { drawSVG: '0% 100%' }, .15)
          .to(this.all, .5, { fill: '#01245E' })
          .add('zoom')
          .to('#preloader', .2, { scale: 100, x: '-2%', ease: ExpoScaleEase.config(0.2, 8) }, 'zoom')
          .to('#oboz', .5, { opacity: 1 }, 'zoom')
          .to('.oboz', 1, { fill: '#01245E' })
          .to('.oboz', 1, { drawSVG: "0% 0%" }, '-=.8')
          .to(this.all, .5, { opacity: 0 })
          .to('.oboz-z', .5, { fill: '#004BC8' }, '-=.5')
    },

    setToDefault () {
      this.tl = new TimelineMax({})
      let eurasia = MorphSVGPlugin.convertToPath('.eurasia')
      let north = MorphSVGPlugin.convertToPath('.north')
      let south = MorphSVGPlugin.convertToPath('.south')
      let oceania = MorphSVGPlugin.convertToPath('.oceania')
      let africa = MorphSVGPlugin.convertToPath('.africa')
      this.all = [eurasia, north, south, oceania, africa]
      this.tl.set(this.all, { drawSVG: '0% 0%' })
    }
  }
}

</script>

<style lang="scss">
  .preloader-wrap {
    position: fixed;
    top: 0;
    left: 0;
    bottom: 0;
    right: 0;
    z-index: 19999;
    width: 100%;
    height: 100%;
    display: flex;
    align-items: center;
    justify-content: center;
    overflow: hidden;
    background: $background-color;

    svg {
      width: 200px;
      height: 100px;
    }
  }

  #preloader {
    animation: preloader__tr 4000ms linear infinite normal backwards
  }

  @keyframes preloader__tr {
    0% {
      transform: translate(36px, 36px) rotate(0deg);
      animation-timing-function: cubic-bezier(0.190000, 1, 0.220000, 1)
    }
    25% {
      transform: translate(36px, 36px) rotate(90deg);
      animation-timing-function: cubic-bezier(0.230000, 1, 0.320000, 1)
    }
    50% {
      transform: translate(36px, 36px) rotate(180deg);
      animation-timing-function: cubic-bezier(0.230000, 1, 0.320000, 1)
    }
    75% {
      transform: translate(36px, 36px) rotate(270deg);
      animation-timing-function: cubic-bezier(0.230000, 1, 0.320000, 1)
    }
    100% {
      transform: translate(36px, 36px) rotate(360deg)
    }
  }
</style>
